## git-annex 3.20121017

=== Makefile ===
CFLAGS=-Wall
GIT_ANNEX_TMP_BUILD_DIR?=tmp
IGNORE=-ignore-package monads-fd -ignore-package monads-tf
BASEFLAGS=-Wall $(IGNORE) -outputdir $(GIT_ANNEX_TMP_BUILD_DIR) -IUtility

# If you get build failures due to missing haskell libraries,
# you can turn off some of these features.
#
# If you're using an old version of yesod, enable -DWITH_OLD_YESOD
FEATURES?=$(GIT_ANNEX_LOCAL_FEATURES) -DWITH_ASSISTANT -DWITH_S3 -DWITH_WEBAPP -DWITH_PAIRING

bins=git-annex
mans=git-annex.1 git-annex-shell.1
sources=Build/SysConfig.hs Utility/Touch.hs Utility/Mounts.hs
all=$(bins) $(mans) docs

OS:=$(shell uname | sed 's/[-_].*//')
ifeq ($(OS),Linux)
OPTFLAGS?=-DWITH_INOTIFY
clibs=Utility/libdiskfree.o Utility/libmounts.o
THREADFLAGS=$(shell if test -e  `ghc --print-libdir`/libHSrts_thr.a; then printf -- -threaded; fi)
else
# BSD system
THREADFLAGS=-threaded
OPTFLAGS?=-DWITH_KQUEUE
clibs=Utility/libdiskfree.o Utility/libmounts.o Utility/libkqueue.o
ifeq ($(OS),Darwin)
# Ensure OSX compiler builds for 32 bit when using 32 bit ghc
GHCARCH:=$(shell ghc -e 'print System.Info.arch')
ifeq ($(GHCARCH),i386)
CFLAGS=-Wall -m32
endif
endif
endif

ALLFLAGS = $(BASEFLAGS) $(FEATURES) $(OPTFLAGS) $(THREADFLAGS)

PREFIX=/usr
GHCFLAGS=-O2 $(ALLFLAGS)

ifdef PROFILE
GHCFLAGS=-prof -auto-all -rtsopts -caf-all -fforce-recomp $(ALLFLAGS)
endif

GHCMAKE=ghc $(GHCFLAGS) --make

# Am I typing :make in vim? Do a fast build.
ifdef VIM
all=fast
endif

build: $(all)
	touch build-stamp

sources: $(sources)

# Disables optimisation. Not for production use.
fast: GHCFLAGS=$(ALLFLAGS)
fast: $(bins)

Build/SysConfig.hs: configure.hs Build/TestConfig.hs Build/Configure.hs
	$(GHCMAKE) configure
	./configure

%.hs: %.hsc
	hsc2hs $<

git-annex: $(sources) $(clibs)
	install -d $(GIT_ANNEX_TMP_BUILD_DIR)
	$(GHCMAKE) $@ -o $(GIT_ANNEX_TMP_BUILD_DIR)/git-annex $(clibs)
	ln -sf $(GIT_ANNEX_TMP_BUILD_DIR)/git-annex git-annex

git-annex.1: doc/git-annex.mdwn
	./Build/mdwn2man git-annex 1 doc/git-annex.mdwn > git-annex.1
git-annex-shell.1: doc/git-annex-shell.mdwn
	./Build/mdwn2man git-annex-shell 1 doc/git-annex-shell.mdwn > git-annex-shell.1
git-union-merge.1: doc/git-union-merge.mdwn
	./Build/mdwn2man git-union-merge 1 doc/git-union-merge.mdwn > git-union-merge.1

install-mans: $(mans)
	install -d $(DESTDIR)$(PREFIX)/share/man/man1
	install -m 0644 $(mans) $(DESTDIR)$(PREFIX)/share/man/man1

install-docs: docs install-mans
	install -d $(DESTDIR)$(PREFIX)/share/doc/git-annex
	if [ -d html ]; then \
		rsync -a --delete html/ $(DESTDIR)$(PREFIX)/share/doc/git-annex/html/; \
	fi

install: build-stamp install-docs
	install -d $(DESTDIR)$(PREFIX)/bin
	install $(bins) $(DESTDIR)$(PREFIX)/bin
	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-annex-shell
	runghc Build/InstallDesktopFile.hs $(PREFIX)/bin/git-annex || true

test: $(sources) $(clibs)
	@if ! $(GHCMAKE) -O0 test $(clibs); then \
		echo "** failed to build the test suite" >&2; \
		exit 1; \
	elif ! ./test; then \
		echo "** test suite failed!" >&2; \
		exit 1; \
	fi

testcoverage:
	rm -f test.tix test
	ghc $(GHCFLAGS) -outputdir $(GIT_ANNEX_TMP_BUILD_DIR)/testcoverage --make -fhpc test
	./test
	@echo ""
	@hpc report test --exclude=Main --exclude=QC
	@hpc markup test --exclude=Main --exclude=QC --destdir=.hpc >/dev/null
	@echo "(See .hpc/ for test coverage details.)"

# If ikiwiki is available, build static html docs suitable for being
# shipped in the software package.
ifeq ($(shell which ikiwiki),)
IKIWIKI=@echo "** ikiwiki not found, skipping building docs" >&2; true
else
IKIWIKI=ikiwiki
endif

docs: $(mans)
	$(IKIWIKI) doc html -v --wikiname git-annex --plugin=goodstuff \
		--no-usedirs --disable-plugin=openid --plugin=sidebar \
		--underlaydir=/dev/null --disable-plugin=shortcut \
		--disable-plugin=smiley \
		--plugin=comments --set comments_pagespec="*" \
		--exclude='news/.*'

clean:
	rm -rf $(GIT_ANNEX_TMP_BUILD_DIR) $(bins) $(mans) test configure  *.tix .hpc $(sources) \
		doc/.ikiwiki html dist $(clibs) build-stamp

sdist: clean $(mans)
	./Build/make-sdist.sh

# Upload to hackage.
hackage: sdist
	@cabal upload dist/*.tar.gz

THIRDPARTY_BINS=git curl lsof xargs rsync uuid wget gpg \
	sha1sum sha224sum sha256sum sha384sum sha512sum

LINUXSTANDALONE_DEST=$(GIT_ANNEX_TMP_BUILD_DIR)/git-annex.linux
linuxstandalone:
	$(MAKE) clean
	GIT_ANNEX_LOCAL_FEATURES="$(GIT_ANNEX_LOCAL_FEATURES) -DWITH_OLD_SSH" $(MAKE) git-annex

	rm -rf "$(LINUXSTANDALONE_DEST)"

	cp -R standalone/linux "$(LINUXSTANDALONE_DEST)"

	install -d "$(LINUXSTANDALONE_DEST)/bin"
	cp git-annex "$(LINUXSTANDALONE_DEST)/bin/"
	strip "$(LINUXSTANDALONE_DEST)/bin/git-annex"
	ln -sf git-annex "$(LINUXSTANDALONE_DEST)/bin/git-annex-shell"
	zcat standalone/licences.gz > $(LINUXSTANDALONE_DEST)/LICENSE

	for bin in $(THIRDPARTY_BINS); do \
		cp "$$(which "$$bin")" "$(LINUXSTANDALONE_DEST)/bin/"; \
	done
	
	install -d "$(LINUXSTANDALONE_DEST)/git-core"
	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(LINUXSTANDALONE_DEST)"/git-core && tar x)
	
	touch "$(LINUXSTANDALONE_DEST)/libdirs.tmp"
	for lib in $$(ldd "$(LINUXSTANDALONE_DEST)"/bin/* $$(find "$(LINUXSTANDALONE_DEST)"/git-core/ -type f) | grep -v -f standalone/linux/glibc-libs | grep -v "not a dynamic executable" | egrep '^	' | sed 's/^\t//' | sed 's/.*=> //' | cut -d ' ' -f 1 | sort | uniq); do \
		dir=$$(dirname "$$lib"); \
		install -d "$(LINUXSTANDALONE_DEST)/$$dir"; \
		echo "$$dir" >> "$(LINUXSTANDALONE_DEST)/libdirs.tmp"; \
		cp "$$lib" "$(LINUXSTANDALONE_DEST)/$$dir"; \
		if [ -L "$lib" ]; then \
			link=$$(readlink -f "$$lib"); \
			cp "$$link" "$(LINUXSTANDALONE_DEST)/$$(dirname "$$link")"; \
		fi; \
	done
	sort "$(LINUXSTANDALONE_DEST)/libdirs.tmp" | uniq > "$(LINUXSTANDALONE_DEST)/libdirs"
	rm -f "$(LINUXSTANDALONE_DEST)/libdirs.tmp"

	cd $(GIT_ANNEX_TMP_BUILD_DIR) && tar czf git-annex-standalone-$(shell dpkg --print-architecture).tar.gz git-annex.linux

OSXAPP_DEST=$(GIT_ANNEX_TMP_BUILD_DIR)/build-dmg/git-annex.app
OSXAPP_BASE=$(OSXAPP_DEST)/Contents/MacOS
osxapp:
	$(MAKE) clean
	GIT_ANNEX_LOCAL_FEATURES="$(GIT_ANNEX_LOCAL_FEATURES) -DWITH_OLD_SSH" $(MAKE) git-annex

	rm -rf "$(OSXAPP_DEST)"
	install -d $(GIT_ANNEX_TMP_BUILD_DIR)/build-dmg
	cp -R standalone/osx/git-annex.app "$(OSXAPP_DEST)"

	install -d "$(OSXAPP_BASE)/bin"
	cp git-annex "$(OSXAPP_BASE)/bin/"
	strip "$(OSXAPP_BASE)/bin/git-annex"
	ln -sf git-annex "$(OSXAPP_BASE)/bin/git-annex-shell"
	gzcat standalone/licences.gz > $(OSXAPP_BASE)/LICENSE
	cp $(OSXAPP_BASE)/LICENSE $(GIT_ANNEX_TMP_BUILD_DIR)/build-dmg/LICENSE.txt

	for bin in $(THIRDPARTY_BINS); do \
		cp "$$(which "$$bin")" "$(OSXAPP_BASE)/bin/"; \
	done

	install -d "$(OSXAPP_BASE)/git-core"
	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(OSXAPP_BASE)"/git-core && tar x)

	touch "$(OSXAPP_BASE)/libdirs.tmp"
	for lib in $$(otool -L "$(OSXAPP_BASE)"/bin/* "$(OSXAPP_BASE)"/git-core/* | egrep '^	' | cut -d ' ' -f 1 | sed  's/^	//' | sort | uniq); do \
		dir=$$(dirname "$$lib"); \
		install -d "$(OSXAPP_BASE)/$$dir"; \
		echo "$$dir" >> "$(OSXAPP_BASE)/libdirs.tmp"; \
		cp "$$lib" "$(OSXAPP_BASE)/$$dir"; \
	done
	sort "$(OSXAPP_BASE)/libdirs.tmp" | uniq > "$(OSXAPP_BASE)/libdirs"
	rm -f "$(OSXAPP_BASE)/libdirs.tmp"
	rm -f tmp/git-annex.dmg
	hdiutil create -size 640m -format UDRW -srcfolder $(GIT_ANNEX_TMP_BUILD_DIR)/build-dmg \
		-volname git-annex -o tmp/git-annex.dmg
	rm -f tmp/git-annex.dmg.bz2
	bzip2 tmp/git-annex.dmg

.PHONY: $(bins) test install

=== debian/changelog ===
git-annex (3.20121017) unstable; urgency=low

  * Fix zombie cleanup reversion introduced in 3.20121009.
  * Additional fix to support git submodules.

 -- Joey Hess <joeyh@debian.org>  Tue, 16 Oct 2012 21:10:14 -0400

git-annex (3.20121016) unstable; urgency=low

  * vicfg: New file format, avoids ambiguity with repos that have the same
    description, or no description.
  * Bug fix: A recent change caused git-annex-shell to crash.
  * Better preferred content expression for transfer repos.
  * webapp: Repository edit form can now edit the name of a repository.
  * webapp: Make bare repositories on removable drives, as there is nothing
    to ensure non-bare repos get updated when syncing.
  * webapp: Better behavior when pausing syncing to a remote when a transfer
    scan is running and queueing new transfers for that remote.
  * The standalone binaries are now built to not use ssh connection caching,
    in order to work with old versions of ssh.
  * A relative core.worktree is relative to the gitdir. Now that this is
    handled correctly, git-annex can be used in git submodules.
  * Temporarily disable use of dbus, as the haskell dbus library blows up
    when losing connection, which will need to be fixed upstream. 

 -- Joey Hess <joeyh@debian.org>  Tue, 16 Oct 2012 15:25:22 -0400

git-annex (3.20121010) unstable; urgency=low

  * Renamed --ingroup to --inallgroup.
  * Standard groups changed to client, transfer, archive, and backup.
    Each of these has its own standard preferred content setting.
  * dead: Remove dead repository from all groups.
  * Avoid unsetting HOME when running certian git commands. Closes: #690193
  * test: Fix threaded runtime hang.
  * Makefile: Avoid building with -threaded if the ghc threaded runtime does
    not exist.
  * webapp: Improve wording of intro display. Closes: #689848
  * webapp: Repositories can now be configured, to change their description,
    their group, or even to disable syncing to them.
  * git config remote.name.annex-sync can be used to control whether
    a remote gets synced.
  * Fix a crash when merging files in the git-annex branch that contain
    invalid utf8.
  * Automatically detect when a ssh remote does not have git-annex-shell
    installed, and set annex-ignore.

 -- Joey Hess <joeyh@debian.org>  Fri, 12 Oct 2012 13:45:21 -0400

git-annex (3.20121009) unstable; urgency=low

  * watch, assistant: It's now safe to git annex unlock files while
    the watcher is running, as well as modify files checked into git
    as normal files. Additionally, .gitignore settings are now honored.
    Closes: #689979
  * group, ungroup: New commands to indicate groups of repositories.
  * webapp: Adds newly created repositories to one of these groups:
    clients, drives, servers
  * vicfg: New command, allows editing (or simply viewing) most
    of the repository configuration settings stored in the git-annex branch.
  * Added preferred content expressions, configurable using vicfg.
  * get --auto: If the local repository has preferred content
    configured, only get that content.
  * drop --auto: If the repository the content is dropped from has
    preferred content configured, drop only content that is not preferred.
  * copy --auto: Only transfer content that the destination repository prefers.
  * assistant: Now honors preferred content settings when deciding what to
    transfer.
  * --copies=group:number can now be used to match files that are present
    in a specified number of repositories in a group.
  * Added --smallerthan, --largerthan, and --inall limits.
  * Only build-depend on libghc-clientsession-dev on arches that will have
    the webapp.
  * uninit: Unset annex.version. Closes: #689852

 -- Joey Hess <joeyh@debian.org>  Tue, 09 Oct 2012 15:13:23 -0400

git-annex (3.20121001) unstable; urgency=low

  * fsck: Now has an incremental mode. Start a new incremental fsck pass
    with git annex fsck --incremental. Now the fsck can be interrupted
    as desired, and resumed with git annex fsck --more.
    Thanks, Justin Azoff
  * New --time-limit option, makes long git-annex commands stop after
    a specified amount of time.
  * fsck: New --incremental-schedule option which is nice for scheduling
    eg, monthly incremental fsck runs in cron jobs.
  * Fix fallback to ~/Desktop when xdg-user-dir is not available.
    Closes: #688833
  * S3: When using a shared cipher, S3 credentials are not stored encrypted
    in the git repository, as that would allow anyone with access to
    the repository access to the S3 account. Instead, they're stored
    in a 600 mode file in the local git repo.
  * webapp: Avoid crashing when ssh-keygen -F chokes on an invalid known_hosts
    file.
  * Always do a system wide installation when DESTDIR is set. Closes: #689052
  * The Makefile now builds with the new yesod by default.
    Systems like Debian that have the old yesod 1.0.1 should set
    GIT_ANNEX_LOCAL_FEATURES=-DWITH_OLD_YESOD
  * copy: Avoid updating the location log when no copy is performed.
  * configure: Test that uuid -m works, falling back to plain uuid if not.
  * Avoid building the webapp on Debian architectures that do not yet
    have template haskell and thus yesod. (Should be available for arm soonish
    I hope).

 -- Joey Hess <joeyh@debian.org>  Mon, 01 Oct 2012 13:56:55 -0400

git-annex (3.20120924) unstable; urgency=low

  * assistant: New command, a daemon which does everything watch does,
    as well as automatically syncing file contents between repositories.
  * webapp: An interface for managing and configuring the assistant.
  * The default backend used when adding files to the annex is changed
    from SHA256 to SHA256E, to simplify interoperability with OSX, media
    players, and various programs that needlessly look at symlink targets.
    To get old behavior, add a .gitattributes containing: * annex.backend=SHA256
  * init: If no description is provided for a new repository, one will


=== debian/control ===
Source: git-annex
Section: utils
Priority: optional
Build-Depends: 
	debhelper (>= 9),
	ghc (>= 7.4),
	libghc-missingh-dev,
	libghc-hslogger-dev,
	libghc-pcre-light-dev,
	libghc-sha-dev,
	libghc-dataenc-dev,
	libghc-http-dev,
	libghc-utf8-string-dev,
	libghc-hs3-dev (>= 0.5.6),
	libghc-testpack-dev,
	libghc-quickcheck2-dev,
	libghc-monad-control-dev (>= 0.3),
	libghc-lifted-base-dev,
	libghc-json-dev,
	libghc-ifelse-dev,
	libghc-bloomfilter-dev,
	libghc-edit-distance-dev,
	libghc-hinotify-dev [linux-any],
	libghc-stm-dev (>= 2.3),
	libghc-dbus-dev [linux-any],
	libghc-yesod-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64],
	libghc-yesod-static-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64],
	libghc-yesod-default-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64],
	libghc-hamlet-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64],
	libghc-clientsession-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64],
	libghc-case-insensitive-dev,
	libghc-http-types-dev,
	libghc-transformers-dev,
	libghc-wai-dev,
	libghc-wai-logger-dev,
	libghc-warp-dev,
	libghc-blaze-builder-dev,
	libghc-blaze-html-dev,
	libghc-crypto-api-dev,
	libghc-network-multicast-dev,
	libghc-network-info-dev,
	ikiwiki,
	perlmagick,
	git,
	uuid,
	rsync,
	openssh-client,
Maintainer: Joey Hess <joeyh@debian.org>
Standards-Version: 3.9.3
Vcs-Git: git://git.kitenet.net/git-annex
Homepage: http://git-annex.branchable.com/

Package: git-annex
Architecture: any
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends},
	git (>= 1:1.7.7),
	uuid,
	rsync,
	wget | curl,
	openssh-client (>= 1:5.6p1)
Recommends: lsof, gnupg
Suggests: graphviz, bup, libnss-mdns
Description: manage files with git, without checking their contents into git
 git-annex allows managing files with git, without checking the file
 contents into git. While that may seem paradoxical, it is useful when
 dealing with files larger than git can currently easily handle, whether due
 to limitations in memory, time, or disk space.
 .
 Even without file content tracking, being able to manage files with git,
 move files around and delete files with versioned directory trees, and use
 branches and distributed clones, are all very handy reasons to use git. And
 annexed files can co-exist in the same git repository with regularly
 versioned files, which is convenient for maintaining documents, Makefiles,
 etc that are associated with annexed files but that benefit from full
 revision control.

=== debian/rules ===
#!/usr/bin/make -f

ARCH = $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ifeq (install ok installed,$(shell dpkg-query -W -f '$${Status}' libghc-yesod-dev 2>/dev/null))
export FEATURES=-DWITH_ASSISTANT -DWITH_S3 -DWITH_OLD_YESOD -DWITH_WEBAPP -DWITH_PAIRING
else
export FEATURES=-DWITH_ASSISTANT -DWITH_S3 -DWITH_PAIRING
endif

%:
	dh $@

# Not intended for use by anyone except the author.
announcedir:
	@echo ${HOME}/src/git-annex/doc/news

## git-annex 3.20121112ubuntu1

=== debian/changelog ===
git-annex (3.20121112ubuntu1) raring; urgency=low

  * Lower libghc-network-protocol-xmpp-dev dependency to 0.4.3-1build2 on
    Ubuntu.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Mon, 26 Nov 2012 04:07:06 +0000

git-annex (3.20121112) unstable; urgency=low

  * assistant: Can use XMPP to notify other nodes about pushes made to other
    repositories, as well as pushing to them directly over XMPP.
  * wepapp: Added an XMPP configuration interface.
  * webapp: Supports pairing over XMPP, with both friends, and other repos
    using the same account.
  * assistant: Drops non-preferred content when possible.
  * assistant: Notices, and applies config changes as they are made to
    the git-annex branch, including config changes pushed in from remotes.
  * git-annex-shell: GIT_ANNEX_SHELL_DIRECTORY can be set to limit it
    to operating on a specified directory.
  * webapp: When setting up authorized_keys, use GIT_ANNEX_SHELL_DIRECTORY.
  * Preferred content path matching bugfix.
  * Preferred content expressions cannot use "in=".
  * Preferred content expressions can use "present".
  * Fix handling of GIT_DIR when it refers to a git submodule.
  * Depend on and use the Haskell SafeSemaphore library, which provides
    exception-safe versions of SampleVar and QSemN.
    Thanks, Ben Gamari for an excellent patch set.
  * file:/// URLs can now be used with the web special remote.
  * webapp: Allow dashes in ssh key comments when pairing.
  * uninit: Check and abort if there are symlinks to annexed content that
    are not checked into git.
  * webapp: Switched to using the same multicast IP address that avahi uses.
  * bup: Don't pass - to bup-split to make it read stdin; bup 0.25
    does not accept that.
  * bugfix: Don't fail transferring content from read-only repos.
    Closes: #691341
  * configure: Check that checksum programs produce correct checksums.
  * Re-enable dbus, using a new version of the library that fixes the memory
    leak.
  * NetWatcher: When dbus connection is lost, try to reconnect.
  * Use USER and HOME environment when set, and only fall back to getpwent,
    which doesn't work with LDAP or NIS.
  * rsync special remote: Include annex-rsync-options when running rsync
    to test a key's presence.
  * The standalone tarball's runshell now takes care of installing a
    ~/.ssh/git-annex-shell wrapper the first time it's run.
  * webapp: Make an initial, empty commit so there is a master branch 
  * assistant: Fix syncing local drives.
  * webapp: Fix creation of rsync.net repositories.
  * webapp: Fix renaming of special remotes.
  * webapp: Generate better git remote names.
  * webapp: Ensure that rsync special remotes are enabled using the same
    name they were originally created using.
  * Bugfix: Fix hang in webapp when setting up a ssh remote with an absolute
    path.

 -- Joey Hess <joeyh@debian.org>  Mon, 12 Nov 2012 10:39:47 -0400

=== debian/control ===
--- 
+++ 
@@ -22,7 +22,7 @@
 	libghc-edit-distance-dev,
 	libghc-hinotify-dev [linux-any],
 	libghc-stm-dev (>= 2.3),
-	libghc-dbus-dev [linux-any],
+	libghc-dbus-dev (>= 0.10.3) [linux-any],
 	libghc-yesod-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64],
 	libghc-yesod-static-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64],
 	libghc-yesod-default-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64],
@@ -35,17 +35,22 @@
 	libghc-wai-logger-dev,
 	libghc-warp-dev,
 	libghc-blaze-builder-dev,
-	libghc-blaze-html-dev,
 	libghc-crypto-api-dev,
 	libghc-network-multicast-dev,
 	libghc-network-info-dev,
+	libghc-safesemaphore-dev,
+	libghc-network-protocol-xmpp-dev (>= 0.4.3-1build2),
+	libghc-gnutls-dev (>= 0.1.4),
+	libghc-xml-types-dev,
+	libghc-async-dev,
 	ikiwiki,
 	perlmagick,
 	git,
 	uuid,
 	rsync,
 	openssh-client,
-Maintainer: Joey Hess <joeyh@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Joey Hess <joeyh@debian.org>
 Standards-Version: 3.9.3
 Vcs-Git: git://git.kitenet.net/git-annex
 Homepage: http://git-annex.branchable.com/
@@ -59,7 +64,7 @@
 	rsync,
 	wget | curl,
 	openssh-client (>= 1:5.6p1)
-Recommends: lsof, gnupg
+Recommends: lsof, gnupg, bind9-host
 Suggests: graphviz, bup, libnss-mdns
 Description: manage files with git, without checking their contents into git
  git-annex allows managing files with git, without checking the file

=== debian/rules ===
#!/usr/bin/make -f

ARCH = $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ifeq (install ok installed,$(shell dpkg-query -W -f '$${Status}' libghc-yesod-dev 2>/dev/null))
export FEATURES=-DWITH_ASSISTANT -DWITH_S3 -DWITH_OLD_URI -DWITH_OLD_YESOD -DWITH_WEBAPP -DWITH_PAIRING -DWITH_XMPP
else
export FEATURES=-DWITH_ASSISTANT -DWITH_S3 -DWITH_OLD_URI -DWITH_PAIRING -DWITH_XMPP
endif

%:
	dh $@

# Not intended for use by anyone except the author.
announcedir:
	@echo ${HOME}/src/git-annex/doc/news

## git-annex 3.20121112ubuntu2

=== debian/changelog ===
git-annex (3.20121112ubuntu2) raring; urgency=low

  * Compilation fixes for the versions of GHC and libraries (mainly Yesod) in
    Raring. Fixes mostly backported from upstream, and slightly altered where
    necessary.
  * Add BD on libghc-extensible-exceptions-dev; newly required with new GHC. 

 -- Iain Lane <iain@orangesquash.org.uk>  Sun, 21 Apr 2013 21:58:31 +0100

=== debian/control ===
--- 
+++ 
@@ -43,6 +43,7 @@
 	libghc-gnutls-dev (>= 0.1.4),
 	libghc-xml-types-dev,
 	libghc-async-dev,
+	libghc-extensible-exceptions-dev,
 	ikiwiki,
 	perlmagick,
 	git,

=== debian/rules ===
#!/usr/bin/make -f

ARCH = $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ifeq (install ok installed,$(shell dpkg-query -W -f '$${Status}' libghc-yesod-dev 2>/dev/null))
export FEATURES=-DWITH_ASSISTANT -DWITH_S3 -DWITH_WEBAPP -DWITH_PAIRING -DWITH_XMPP
else
export FEATURES=-DWITH_ASSISTANT -DWITH_S3 -DWITH_OLD_URI -DWITH_PAIRING -DWITH_XMPP
endif

%:
	dh $@

# Not intended for use by anyone except the author.
announcedir:
	@echo ${HOME}/src/git-annex/doc/news

## git-annex 3.20121112ubuntu3

=== Makefile ===
--- 
+++ 
@@ -1,13 +1,13 @@
 CFLAGS=-Wall
 GIT_ANNEX_TMP_BUILD_DIR?=tmp
-IGNORE=-ignore-package monads-fd -ignore-package monads-tf
-BASEFLAGS=-Wall $(IGNORE) -outputdir $(GIT_ANNEX_TMP_BUILD_DIR) -IUtility
+BASEFLAGS=-Wall -outputdir $(GIT_ANNEX_TMP_BUILD_DIR) -IUtility
 
 # If you get build failures due to missing haskell libraries,
 # you can turn off some of these features.
 #
 # If you're using an old version of yesod, enable -DWITH_OLD_YESOD
-FEATURES?=$(GIT_ANNEX_LOCAL_FEATURES) -DWITH_ASSISTANT -DWITH_S3 -DWITH_WEBAPP -DWITH_PAIRING
+# Or with an old version of the uri library, enable -DWITH_OLD_URI
+FEATURES?=$(GIT_ANNEX_LOCAL_FEATURES) -DWITH_ASSISTANT -DWITH_S3 -DWITH_WEBAPP -DWITH_PAIRING -DWITH_XMPP -DWITH_DNS
 
 bins=git-annex
 mans=git-annex.1 git-annex-shell.1
@@ -16,9 +16,13 @@
 
 OS:=$(shell uname | sed 's/[-_].*//')
 ifeq ($(OS),Linux)
-OPTFLAGS?=-DWITH_INOTIFY
+OPTFLAGS?=-DWITH_INOTIFY -DWITH_DBUS
 clibs=Utility/libdiskfree.o Utility/libmounts.o
 THREADFLAGS=$(shell if test -e  `ghc --print-libdir`/libHSrts_thr.a; then printf -- -threaded; fi)
+else
+ifeq ($(OS),SunOS)
+# Solaris is not supported by the assistant or watch command.
+FEATURES:=$(shell echo $(FEATURES) | sed -e 's/-DWITH_ASSISTANT//' -e 's/-DWITH_WEBAPP//')
 else
 # BSD system
 THREADFLAGS=-threaded
@@ -32,6 +36,7 @@
 endif
 endif
 endif
+endif
 
 ALLFLAGS = $(BASEFLAGS) $(FEATURES) $(OPTFLAGS) $(THREADFLAGS)
 
@@ -139,11 +144,10 @@
 	@cabal upload dist/*.tar.gz
 
 THIRDPARTY_BINS=git curl lsof xargs rsync uuid wget gpg \
-	sha1sum sha224sum sha256sum sha384sum sha512sum
+	sha1sum sha224sum sha256sum sha384sum sha512sum cp
 
 LINUXSTANDALONE_DEST=$(GIT_ANNEX_TMP_BUILD_DIR)/git-annex.linux
 linuxstandalone:
-	$(MAKE) clean
 	GIT_ANNEX_LOCAL_FEATURES="$(GIT_ANNEX_LOCAL_FEATURES) -DWITH_OLD_SSH" $(MAKE) git-annex
 
 	rm -rf "$(LINUXSTANDALONE_DEST)"
@@ -182,7 +186,6 @@
 OSXAPP_DEST=$(GIT_ANNEX_TMP_BUILD_DIR)/build-dmg/git-annex.app
 OSXAPP_BASE=$(OSXAPP_DEST)/Contents/MacOS
 osxapp:
-	$(MAKE) clean
 	GIT_ANNEX_LOCAL_FEATURES="$(GIT_ANNEX_LOCAL_FEATURES) -DWITH_OLD_SSH" $(MAKE) git-annex
 
 	rm -rf "$(OSXAPP_DEST)"
@@ -218,4 +221,8 @@
 	rm -f tmp/git-annex.dmg.bz2
 	bzip2 tmp/git-annex.dmg
 
+# used by ./ghci
+getflags:
+	@echo $(ALLFLAGS) $(clibs)
+
 .PHONY: $(bins) test install

=== debian/changelog ===
git-annex (3.20121112ubuntu3) raring; urgency=low

  * Build the webapp on powerpc, since it has Template Haskell now.
  * Backport from upstream:
    - Fix build of assistant without yesod.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 22 Apr 2013 10:12:22 +0100

=== debian/control ===
--- 
+++ 
@@ -23,11 +23,11 @@
 	libghc-hinotify-dev [linux-any],
 	libghc-stm-dev (>= 2.3),
 	libghc-dbus-dev (>= 0.10.3) [linux-any],
-	libghc-yesod-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64],
-	libghc-yesod-static-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64],
-	libghc-yesod-default-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64],
-	libghc-hamlet-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64],
-	libghc-clientsession-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64],
+	libghc-yesod-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
+	libghc-yesod-static-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
+	libghc-yesod-default-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
+	libghc-hamlet-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
+	libghc-clientsession-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
 	libghc-case-insensitive-dev,
 	libghc-http-types-dev,
 	libghc-transformers-dev,

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 ifeq (install ok installed,$(shell dpkg-query -W -f '$${Status}' libghc-yesod-dev 2>/dev/null))
 export FEATURES=-DWITH_ASSISTANT -DWITH_S3 -DWITH_WEBAPP -DWITH_PAIRING -DWITH_XMPP
 else
-export FEATURES=-DWITH_ASSISTANT -DWITH_S3 -DWITH_OLD_URI -DWITH_PAIRING -DWITH_XMPP
+export FEATURES=-DWITH_ASSISTANT -DWITH_S3 -DWITH_PAIRING -DWITH_XMPP
 endif
 
 %:

## git-annex 3.20121112ubuntu4

=== debian/changelog ===
git-annex (3.20121112ubuntu4) raring; urgency=low

  * Check for the 'ok installed' substring in the dpkg-query output when
    determining whether Yesod is installed; this matches against the 'current'
    state, rather than the 'desired' and 'current' states that checking for
    'install ok installed' does. The latter is a problem on the buildds where
    the desired state is 'purge'. (LP: #1084693)

 -- Iain Lane <laney@ubuntu.com>  Mon, 10 Jun 2013 22:05:18 +0100

=== debian/rules ===
#!/usr/bin/make -f

ARCH = $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ifeq (ok installed,$(findstring ok installed,$(shell dpkg-query -W -f '$${Status}' libghc-yesod-dev 2>/dev/null)))
export FEATURES=-DWITH_ASSISTANT -DWITH_S3 -DWITH_WEBAPP -DWITH_PAIRING -DWITH_XMPP
else
export FEATURES=-DWITH_ASSISTANT -DWITH_S3 -DWITH_PAIRING -DWITH_XMPP
endif

%:
	dh $@

# Not intended for use by anyone except the author.
announcedir:
	@echo ${HOME}/src/git-annex/doc/news
